﻿// NicoZero_extendCommentLog.js
// ZeroWatchのコメントログを拡張(ユーザーIDを表示)
// 2012/06/03	ver 1.00
// 2012/06/09	ver 1.01	仕様変更に対応
// 2013/08/03	ver 2.00	仕様変更に対応
// 2014/02/04	ver 2.01	仕様変更に対応（NG追加後にコメント欄に戻らなかったのを修正）
// 2014/02/19	ver 2.1		userIDでソートできるように変更。nicoruCountとscore（何のscoreか不明ｗNGかな？）、postedCount（コメント数）を追加。設定画面を作成
// 2014/02/20	ver 2.11	ちょっとした修正
// 2014/02/23	var 2.12	過去ログにも対応・タブの横幅変更に対応 thx>>222
// 2014/03/04	var 2.13	jQuery1.11に対応（$(selector).live(type, fn)→$(document).on(type, selector, fn)）
//							ユーザーIDでコメント抽出時に、再度ユーザーIDをクリックした時の設定を作成（全コメント表示 / NG / なにもしない）
// 2014/03/30	var 2.14	コメント検索を可能に（設定から有効化） / ログの幅を自動調節に
// 2014/04/26	var 2.15	コマンドも表示できるように変更 / コメント検索に正規表現追加（最初と最後をスラッシュにする→例：/search\s+word/） / ログが横に長くなった際表示位置を中央に調整
// 2014/07/23	var 2.16	動画一覧を見るときに画面サイズが小さくなった動画が黒くなっていたのを修正
// 2014/08/05	var 2.17	仕様変更に対応
// 2014/09/09	var 2.18	各ユーザーのコメント数が表示されない時に、ユーザー選択したら計算されるように
// 2014/09/14	var 2.19	コメント右クリック→検索が機能してなかったので修正

jQuery(function(){
	var su = SettingUtil_pr_nl.getInstance("extendCommentLog");
	var isDebug = su.getSetting("isDebug", false);
	function debugLog(arg1){
		if (isDebug && window.console && typeof window.console.log !== "undefined") window.console.log(arg1);
	}
	// setTimeout(arguments.callee, 500);対策
	var $ = jQuery;
//	debugLog("NicoZero_extendCommentLog load");
	try {
		var _CommentContextMenu			 = WatchApp.namespace.view.player.comment.CommentContextMenu;
		var _CommentHtmlFactory			 = WatchApp.namespace.view.player.comment.CommentHtmlFactory;
		var _commentPanelViewController	 = WatchApp.namespace.init.PlayerInitializer.commentPanelViewController;
		var _contentManager				 = _commentPanelViewController.contentManager;
		var _commentContent				 = _commentPanelViewController.commentContent;
		var _commentPoolContainer		 = _commentPanelViewController.commentPoolContainer;
		var _commentListModel			 = _commentPanelViewController.commentListModel;
	} catch(e) {
		return setTimeout(arguments.callee, 300);
	}
//	debugLog("NicoZero_extendCommentLog START");
	// 設定ここから
	var addTypeList = [
		// type（プロパティ名）, 見出しの表示, 説明, 左側に表示するか
		["postedCount", "C", "このユーザーのコメント数", true],
		["userID", "ユーザーID", "ユーザーID", true],
		["command", "コマンド", "コマンド"],
		["nicoruCount", "N", "ニコるカウント"],
		["score", "S", "Score"]
	];
	// 設定ここまで
	var fn_Comdisp_userID = function (jQ_Elem, obj){
		if (typeof jQ_Elem.find !== "function") jQ_Elem = $(jQ_Elem);
		var userID = String(obj.userID);
		jQ_Elem.find(".userID").text((obj.isPremium ? "[P]" : "") + userID.slice(0,8)).attr("title", userID);
	};
	var fn_Comdisp_command = function (jQ_Elem, obj, type){
		if (typeof jQ_Elem.find !== "function") jQ_Elem = $(jQ_Elem);
		// 184は多すぎるので削除
		var command = (" " + obj[type] + " ").replace(/\s184\s/, " ");
		// 色コメはその色にする (red2など→red)
		var command_html = command.replace(/\s((white(?=2)|red|pink|orange|yellow|green|cyan|blue|purple|black)2?)\s/g, ' <span style="color:$2;">$1</span> ');
		// trim (trim関数って全ブラウザにあるかな？)
		command = command.replace(/^\s+|\s+$/g, "");
		command_html = command_html.replace(/^\s+|\s+$/g, "");
		if (command) {
			jQ_Elem.find("." + type).html(command_html).attr("title", command);
		} else {
			jQ_Elem.find("." + type).text("　").attr("title", "");
		}
	};
	var fn_Comdisp_other = function (jQ_Elem, obj, type){
		if (typeof jQ_Elem.find !== "function") jQ_Elem = $(jQ_Elem);
		jQ_Elem.find("." + type).text(obj[type] || "　").attr("title", obj[type]);
	};
	var addTypeListObj = {};
	addTypeListObj.postedCount = {};
	addTypeListObj.postedCount.isNumeric = true;
	addTypeListObj.postedCount.fn_Comdisp = fn_Comdisp_other;
	addTypeListObj.userID = {};
	addTypeListObj.userID.isNumeric = false;
	addTypeListObj.userID.fn_Comdisp = fn_Comdisp_userID;
	addTypeListObj.command = {};
	addTypeListObj.command.isNumeric = false;
	addTypeListObj.command.fn_Comdisp = fn_Comdisp_command;
	addTypeListObj.nicoruCount = {};
	addTypeListObj.nicoruCount.isNumeric = true;
	addTypeListObj.nicoruCount.fn_Comdisp = fn_Comdisp_other;
	addTypeListObj.score = {};
	addTypeListObj.score.isNumeric = true;
	addTypeListObj.score.fn_Comdisp = fn_Comdisp_other;
	// コメント欄表示関数
	var oldCreate = _CommentHtmlFactory.create;
	_CommentHtmlFactory.create = function (obj) {
		var jQ_Elem = oldCreate.apply(_CommentHtmlFactory, arguments);
		for (var i = 0, len = addTypeList.length; i < len; i++) {
			var type = addTypeList[i][0];
			addTypeListObj[type].fn_Comdisp(jQ_Elem, obj, type);
		}
//		debugLog("create");
		if (obj.message.indexOf("\n") !== -1) $(jQ_Elem).find(".comment").text("[" + (obj.message.match(/\n/g).length + 1) + "行]" + obj.message.replace(/\n/g, "<\\n>"));
		return jQ_Elem;
	};
	var oldCreateNoJquery = _CommentHtmlFactory.createNoJquery;
	_CommentHtmlFactory.createNoJquery = function (obj) {
		var jQ_Elem = oldCreateNoJquery.apply(_CommentHtmlFactory, arguments);
		for (var i = 0, len = addTypeList.length; i < len; i++) {
			var type = addTypeList[i][0];
			addTypeListObj[type].fn_Comdisp(jQ_Elem, obj, type);
		}
//		debugLog("createNoJquery");
//		debugLog(b);
//		debugLog(a.comment);
		if (obj.message.indexOf("\n") !== -1) $(jQ_Elem).find(".comment").text("[" + (obj.message.match(/\n/g).length + 1) + "行]" + obj.message.replace(/\n/g, "<\\n>"));
		return jQ_Elem;
	};
	var ExtComLogClassName = "extendCommentLog";
	
//	var header = $("#commentDefault, #commentLog").find(".commentTableHeader .cell");
	var header = $(_contentManager._contents.comment.$commentTableHeader).add(_contentManager._contents.log_comment.$commentTableHeader).find(".cell");
	var template = _CommentHtmlFactory.$template;
	for (var i = 0, len = addTypeList.length; i < len; i++) (function (type, type_caption, type_description, insertFirst){
		var span_template = document.createElement("span");
		span_template.className = type + " " + ExtComLogClassName;
		
		var spanHeadereader = document.createElement("span");
		spanHeadereader.className = type + " col sortable " + ExtComLogClassName;
		spanHeadereader.title = type_description;
		spanHeadereader.innerHTML = type_caption + '<span class="default">△</span><span class="down">▼</span><span class="up">▲</span><span class="resizer" style="display: block;"></span>';
		$(spanHeadereader).attr("data-type", type);

		
		if (su.getSetting(type, type === "userID") === false) {
			span_template.style.display = "none";
			spanHeadereader.style.display = "none";
		}
		
		if (insertFirst) template.find(".comment").before(span_template);
		else  template.append(span_template);
		//_CommentHtmlFactory.reset($(template));
		_CommentHtmlFactory.template = Jarty.compile(template.html());
		
		header.find("span." + (insertFirst ? "comment" : "padding")).before(spanHeadereader);
//		header.find("span" + (insertFirst ? ":first" : ".padding")).before($(spanHeadereader).clone()[0]);
		header.find("." + type).click(function () {
			_commentContent.onCommentHeaderClicked(type);
		});
	}).apply(null, addTypeList[i]);
	
	var header_setting = $(_contentManager._contents.log_comment.$settingHeader).add(_contentManager._contents.comment.$settingHeader);
	
	var useSearchBox = su.getSetting("useSearchBox", false);
	var nowExtracting_Search = false;
	header_setting.find(".threadSelectPanel").after('<input class="extendCommentLog_commentSearchBox" type="text" size="10" placeholder="コメントから検索して抽出" title="コメントから検索して抽出\nEnterで検索">');
	header_setting.find(".extendCommentLog_commentSearchBox").css("margin-bottom", "4px").keydown(function(evt){
		if (evt.keyCode === 13) {	// Enter : 検索（ユーザーIDで抽出中でも全コメントから検索）
			var word = this.value.replace(/(^[\s　]+)|([\s　]+$)/g, "");
			if (word) {
				var name = _commentListModel.getListName();
				if (nowExtracting) {
					// 保存中の全コメントから検索するため、現在のコメントからは何もしない
					if (nowExtracting_userId) {
						// NGボタンなどを隠す
						header_setting.find(".extendCommentLog_ngUserComment").hide();
					}
				} else {
					backupComment[name] = _commentPoolContainer._container[name].slice();
				}
				var bk = backupComment[name];
				var arr = [];
			//	for (var i = 0, len = bk.length; i < len; i++) if (bk[i].message.indexOf(word) !== -1) arr.push(bk[i]);
				arr = searchComment(bk, word);
				_commentPoolContainer._container[name] = arr;
				_commentListModel.change(name);
				nowExtracting = true;
				nowExtracting_userId = false;
				nowExtracting_Search = word;
				$(".extendCommentLog_showAllComment, .extendCommentLog_ngWordComment").css("display", "inline");
				$(".extendCommentLog_ngWordComment span").text(arr.length);
			} else {
				showAllComment();
			}
		} else if (evt.keyCode === 27) {	// Esc : フォーカスを外す
			this.blur();
		}
	});
	function searchComment(allComment, word){
		var arr = [];
		if (word.match(/^[/](.*)[/]$/)) {
			var reg = new RegExp(RegExp.$1);
			for (var i = 0, len = allComment.length; i < len; i++) if (reg.test(allComment[i].message)) arr.push(allComment[i]);
		} else {
			word = word.toLowerCase();
			for (var i = 0, len = allComment.length; i < len; i++) if (allComment[i].message.toLowerCase().indexOf(word) !== -1) arr.push(allComment[i]);
		}
		return arr;
	}
	if (!useSearchBox) header_setting.find(".extendCommentLog_commentSearchBox").hide();
	
	function setCommentTableWidth(){
		var header = $(".commentTableHeader .col:visible");
		var newWidth = header.length * (2 + 4 + 1) + WatchApp.namespace.view.player.comment.CommentPanelViewConstants.SCROLL_BAR_WIDTH + 10; // 15:縦スクロールバー、12:padding=(5+1)*2
		header.each(function(){
			newWidth += $(this).width();
		});
		var diffWidth = newWidth - $("#playerTabContainer").width();
		document.getElementById("playerTabContainer").style.width = newWidth + "px";
//		document.getElementById("chipWallList").style.right = (100 - diffWidth) + "px";
		$("#playerTabContainer .playerTabHeader .playerTabItem").css("width", (newWidth / 2) + "px");
		
		var playerCommentWidth = $("#playerNicoplayer").width() + newWidth;
		var paaWidth = $("#playerAlignmentArea").width();
		var overWidth = playerCommentWidth - paaWidth;
		var wWidth = $(window).width();
		var ml;
		// 横スクロールバーが出る時は左側に寄せる
		if (wWidth < playerCommentWidth) ml = (wWidth - paaWidth) / 2;
		else ml = overWidth / 2;
		if (ml < 0) ml = 0;
		// 壁紙変更ボタン位置
		var cwlr = overWidth - ml + 40;
		cssUtil1.set("#chipWallList", "right: -" + cwlr + "px");
		// 中央寄せ
		cssUtil2.set("#playerAlignmentArea:not(.size_small) #playerContainer:not(.full_with_browser)", "margin-left: -" + ml + "px !important;");
	//	cssUtil1.set(".size_normal #playerContainer:not(.full_with_browser)", "margin-left: -" + (150 + (newWidth - 326) / 4) + "px !important;");
	//	cssUtil2.set(".size_medium #playerContainer:not(.full_with_browser)", "margin-left: -" + (150 + (newWidth - 326) / 4) + "px !important;");
	}
	var cssUtil1 = WatchApp.ns.util.CSSUtil.create();
	var cssUtil2 = WatchApp.ns.util.CSSUtil.create();
	// ページ表示時に1回実行
	window.setTimeout(setCommentTableWidth, 1000);
	// プレイヤーサイズ変更したら実行（WatchAppの解読難しい・・・）
	WatchJsApi.player.onPlayerScreenModeChanged(function(obj){
		if (WatchJsApi.player.PlayerScreenMode.BROWSER_FULL !== obj._mode) {
			setCommentTableWidth();
		}
	});
	// ウィンドウサイズ変更（完了）時に実行
	var tId = null;
	$(window).resize(function() {
		if (tId !== null) clearTimeout(tId);
		tId = setTimeout(setCommentTableWidth, 100);
	});
	// コメント幅リセット時にも実行
	$(document).on("click", ".panelTableHeaderContextMenu", function (evt){
		window.setTimeout(setCommentTableWidth, 100);
	});
	// コメント幅変更完了時に実行
	WatchApp.ns.view.player.comment.CommentPanelColumnResizer.addEventListener("endDrag", setCommentTableWidth);
	/* // ドラッグ完了で自動実行に切り替え↑
	header_setting.find(".threadSelectPanel").after('<button class="extendCommentLog_setCommentTableWidth" title="コメントログの幅をあわせる">幅</button>');
	header_setting.find(".extendCommentLog_setCommentTableWidth").click(setCommentTableWidth).css("margin-bottom", "4px");
	//*/
	
	/*
#chipWallList { right:-140px; }
#playerCommentPanelOuter { width: 580px !important; right:-580px !important; }
#playerCommentPanel { width: 574px; }
#playerTabWrapper { right: -259px; width: 585px; }
#playerTabContainer .playerTabHeader .playerTabItem { width:193px; }
#playerCommentPanel .section .commentTable span.comment { width:220px; }
*/
	/*
	WatchApp.ns.util.CommentListUtil.sort = function (a, f, h) {
		switch (a) {
		case "resNo":
			b.sortByResNo(f, h);
			break;
		case "vpos":
			b.sortByVpos(f, h);
			break;
		case "date":
			b.sortByDate(f, h);
			break;
		case "message":
			b.sortByMessage(f, h);
			break;
		default:
			b.sortByResNo(f, h)
		}
	};
	*/
	var default_sort = WatchApp.ns.util.CommentListUtil.sort;
	var b = WatchApp.ns.util.CommentListUtil;
	WatchApp.ns.util.CommentListUtil.sort = function(a, f, h){
		for (var i = 0, len = addTypeList.length; i < len; i++) {
			var type = addTypeList[i][0];
			if (a === type) {
				if (addTypeListObj[type].isNumeric) {
					b._sortComments(type, f, "undefined" !== typeof h ? h : !0, b._numericSort, b._reverseNumericSort)
				} else {
					b._sortComments(type, f, "undefined" !== typeof h ? h : !0, b._stringSort, b._reverseStringSort)
				}
				return;
			}
		}
		default_sort.apply(b, arguments);
	};
	
	
	var backupComment = {};
	var nowUserCommentFirst = null;
	
	var nowExtracting = false;
	var nowExtracting_userId = false;
	
	// ユーザー選択中にコメントが更新された時対策
	var oldUpdate = _commentPoolContainer.update;
	_commentPoolContainer.update = function (name, b){
		var b_new = function(c){
			// c:現在のコメント
			// b(c)：新規コメがマージされる
			c = b(nowExtracting ? backupComment[name] : c);
			
			addPostedCount(c);
			
			if (nowExtracting) {
		//		debugLog("NicoZero_extendCommentLog：_commentPoolContainer.update:nowExtracting");
				backupComment[name] = c;
				var r = [];
				if (nowExtracting_userId) {
					for (var i = 0, len = c.length; i < len; i++) if (c[i].userID === _userID) r.push(c[i]);
				} else if (nowExtracting_Search) {
					var word = nowExtracting_Search;
				//	for (var i = 0, len = c.length; i < len; i++) if (c[i].message.indexOf(word) !== -1) r.push(c[i]);
					r = searchComment(c, word);
				}
				return r;
			} else {
				return c;
			}
		};
		/*
		var b_new = nowExtracting ? function(c){
			c = b(c);
			backupComment[name] = b(backupComment[name]);
			var r = [];
			for (var i = 0, len = c.length; i < len; i++){
				if (c[i].userID === _userID) r.push(c[i]);
			}
			return r;
		} : b;
		*/
//		console.log(name);
//		console.log([WatchApp.namespace.init.PlayerInitializer.commentPanelViewController.commentListContainer._current.comments.length,WatchApp.namespace.init.PlayerInitializer.commentPanelViewController.commentPoolContainer._container["commentlist:main"].length]);
		oldUpdate.call(_commentPoolContainer, name, b_new);
//		console.log([WatchApp.namespace.init.PlayerInitializer.commentPanelViewController.commentListContainer._current.comments.length,WatchApp.namespace.init.PlayerInitializer.commentPanelViewController.commentPoolContainer._container["commentlist:main"].length]);
	};
	
	// c：参照
	function addPostedCount(c){
		var count  = {};
		for (var i = 0, len = c.length; i < len; i++){
			var id = c[i].userID;
			if (typeof count[id] === "undefined") count[id] = 1;
			else count[id]++;
		}
		for (var i = 0, len = c.length; i < len; i++){
			c[i].postedCount = count[c[i].userID];
		}
	}
	
	
	var _userID;
	var userIdSecondClick_ShowAll = "ShowAll";
	var userIdSecondClick_NG = "NG";
	var userIdSecondClick_DoNothing = "DoNothing"; // 実は未使用
	var userIdSecondClick = su.getSetting("userIdSecondClick", userIdSecondClick_ShowAll);
//	$("#commentDefault .commentTableContainerInner .userID").live("click", function () {
//	$("#commentDefault .userID, #commentLog .userID").live("click", function () {
	$(document).on("click", ".commentTableContainer .userID", function () {
		if (nowExtracting && nowExtracting_userId) {
			if (userIdSecondClick === userIdSecondClick_ShowAll) return showAllComment();
			if (userIdSecondClick === userIdSecondClick_NG) return fn_ngUserComment();
			return;
		}
		_userID = this.title;
		var name = _commentListModel.getListName();
		if (nowExtracting_Search) {
			header_setting.find(".extendCommentLog_commentSearchBox").val("");
			header_setting.find(".extendCommentLog_ngWordComment").hide();
		} else {
			backupComment[name] = _commentPoolContainer._container[name].slice();
		}
		
		addPostedCount(backupComment[name]);
		
		var bk = backupComment[name];
		var arr = [];
		for (var i = 0, len = bk.length; i < len; i++) if (bk[i].userID === _userID) arr.push(bk[i]);
		_commentPoolContainer._container[name] = arr;
		_commentListModel.change(name);
		$(".extendCommentLog_showAllComment, .extendCommentLog_ngUserComment").css("display", "inline");
		$(".extendCommentLog_ngUserComment span").text(arr.length);
		nowUserCommentFirst = arr[0];
		autoScrollOn();
		nowExtracting = true;
		nowExtracting_userId = true;
		nowExtracting_Search = false;
	});
	// 全コメント表示
	window.showAllComment = function(){
		nowExtracting = false;
		nowExtracting_userId = false;
		nowExtracting_Search = false;
		var name = _commentListModel.getListName();
		// 重複分を削除(ようわからん。)
		var check = [];
		var res = [];
		for (var i = 0, len = backupComment[name].length; i < len; i++){
			var resNo = backupComment[name][i].resNo;
			if (!check[resNo]) {
				check[resNo] = 1;
				res.push(backupComment[name][i]);
			}
		}
		backupComment[name] = res;
		// ここまで
		_commentPoolContainer._container[name] = backupComment[name];
		_commentListModel.change(name);
		header_setting.find(".extendCommentLog_showAllComment, .extendCommentLog_ngUserComment, .extendCommentLog_ngWordComment").hide();
		header_setting.find(".extendCommentLog_commentSearchBox").val("");
		autoScrollOn();
	};
	// 全コメント表示ボタン
//	var header_setting = $("#commentDefaultHeader");
//	header_setting.append($('<button class="extendCommentLog_showAllComment">ALL COMMENT</button>').click(showAllComment));
	header_setting.find(".threadSelectPanel").after($('<button class="extendCommentLog_showAllComment">全表示</button>').click(showAllComment));
	header_setting.find(".extendCommentLog_showAllComment").css("margin-bottom", "4px").hide();
	
	// ユーザーIDで抽出中のユーザーNGボタン
	header_setting.find(".threadSelectPanel").after($('<button class="extendCommentLog_ngUserComment">NG(USER):<span></span>件</button>').click(fn_ngUserComment));
	header_setting.find(".extendCommentLog_ngUserComment").css("margin-bottom", "4px").hide();
	function fn_ngUserComment(){
		if (nowUserCommentFirst) {
			/*
			$.each(_CommentContextMenu.onUserNgClicked, function (a, d) {
					d(nowUserCommentFirst);
			});
			*/
//			$(".ngSetting a").click();
//			$("a.ngAddPanelTriger").click();
//↑2つはなくても良くなった
			$(".ngInputText input").val(nowUserCommentFirst.userID);
			$('.addNglist input[name="ngType"][value="user_id"]').click();
			$(".ngAddButton").click();
			nowNGAdding = true;
			showAllComment();
		}
	}
	// 検索で抽出中のNGボタン
	header_setting.find(".threadSelectPanel").after($('<button class="extendCommentLog_ngWordComment">NG(WORD):<span></span>件</button>').click(fn_ngWordComment));
	header_setting.find(".extendCommentLog_ngWordComment").css("margin-bottom", "4px").hide();
	function fn_ngWordComment(){
		if (nowExtracting_Search) {
			$(".ngInputText input").val(nowExtracting_Search.match(/^[/](.*)[/]$/) ? RegExp.$1 : nowExtracting_Search);
			$('.addNglist input[name="ngType"][value="message"]').click();
			$(".ngAddButton").click();
			nowNGAdding = true;
			showAllComment();
		}
	}
	var nowNGAdding = false;
	WatchApp.namespace.model.player.NicoPlayerConnector.playerAreaConnector.addEventListener("onNGAdded", function(){
		if (nowNGAdding) {
			$(".playerTabItem.comment").click();
			nowNGAdding = false;
		}
	});
	
	window.autoScrollOn = function (){
		setTimeout(function(){
			$(".headerIcon.autoScroll.enabled.off").click();
			/*
			var _commentPanelSettingView = _commentPanelViewController.commentPanelSettingView;
			_commentPanelSettingView.updateAutoScroll(true);
		//	$(".enableAutoScroll input").click();
			_commentPanelSettingView.autoScrollNotifier.start(!0);//clickだけだと表示が変わらない
			*/
		}, 100);
	};
	
	// 右クリック時メニュー拡張
	function nicoSearch(word, type){
		var _contentViews = WatchApp.namespace.init.VideoExplorerInitializer.videoExplorerView._contentListView._contentViews;
//		window.console && console.log([word, type, "WatchApp.namespace.init.VideoExplorerInitializer.videoExplorerView._contentListView._contentViews", _contentViews]);
		
		// 何番目に保存されるのか知らんから全部使ってみる。
		for (var key in _contentViews) {
			try {
				_contentViews[key]._searchBoxView.dispatchEvent("search", {
					searchWord: word, 
					searchType: type
				});
				break;
			} catch(e) {}
		}
		/*
		WatchApp.namespace.init.ComponentInitializer.videoSelection.searchBoxVC.dispatchEvent("searched", {
			word: word,
			searchType: type
		}, function(){
			// 検索結果表示後に実行する関数らしい？
		});
		//*/
		// 検索結果にスクロール(嫌な人はコメントアウトで。)
	//	scrollTo(0, document.getElementById("searchResultExplorer").offsetTop);
	}
	var SearchType = WatchApp.namespace.components.nicosearchstatus.model.SearchType;
	// KEYWORD, TAG
	_CommentContextMenu.$contextMenuContainer.find("ul.body").append(
		$('<li>キーワード検索</li>').click(function(){
			nicoSearch($("#commentContextMenuContainer .comment").val(), SearchType.KEYWORD);
			//window.open("/search/" + encodeURIComponent(word));
		}).append(
			$("<span> (<span>選択</span>)</span>").click(function(){
				event.stopPropagation();
				var word = window.prompt("検索ワードを残してEnter(OK)でキーワード検索", $("#commentContextMenuContainer .comment").val());
				if (!word) return;
				nicoSearch(word, SearchType.KEYWORD);
			}).find("span").hover(fn_bgc_change_on, fn_bgc_change_off).parent()
		)
	)
	.append(
		$('<li>タグ検索</li>').click(function(){
			nicoSearch($("#commentContextMenuContainer .comment").val(), SearchType.TAG);
			//window.open("/tag/" + encodeURIComponent(word));
		}).append(
			$("<span> (<span>選択</span>)</span>").click(function(){
				event.stopPropagation();
				var word = window.prompt("検索ワードを残してEnter(OK)でタグ検索", $("#commentContextMenuContainer .comment").val());
				if (!word) return;
				nicoSearch(word, SearchType.TAG);
			}).find("span").hover(fn_bgc_change_on, fn_bgc_change_off).parent()
		)
	)
	.append(
		$('<li>google検索</li>').click(function(){
			window.open("http://www.google.co.jp/search?hl=ja&q=" + encodeURIComponent($("#commentContextMenuContainer .comment").val()));
		}).append(
			$("<span> (<span>選択</span>)</span>").click(function(event){
				event.stopPropagation();
				var word = window.prompt("検索ワードを残してEnter(OK)でgoogle検索", $("#commentContextMenuContainer .comment").val());
				if (!word) return;
				window.open("http://www.google.co.jp/search?hl=ja&q=" + encodeURIComponent(word));
			}).find("span").hover(fn_bgc_change_on, fn_bgc_change_off).parent()
		)
	);
//	$("#commentContextMenuContainer").click(autoScrollOn);
	function fn_bgc_change_on(){
		this.style.backgroundColor = "orange";
	}
	function fn_bgc_change_off(){
		this.style.backgroundColor = "";
	}
	
	
	/***	設定画面の作成	***/
	var esp = new NicoGinza_extendSettingPanel("extendCommentLog", "拡張ログ", "コメントログにユーザーIDを表示する拡張");
	if (esp.IsEnabled) {
		var DEFALUT_VALUE_TRUE = true;
		var DEFALUT_VALUE_FALSE = false;
		esp.start_SettingUtil_pr_nl();
		esp.addElement('<div class="left"></div><div class="right"></div>');
		esp.addElement('<p>・表示する情報</p>', ".left");
		for (var i = 0, len = addTypeList.length; i < len; i++) (function(arg){
			var type = arg[0];
			var desc = arg[2];
			esp.addSettingElementCheckbox(type, type === "userID", desc, function(value){
				var header = $("#commentDefault, #commentLog").find(".commentTableHeader .cell ." + type);
				var template = _CommentHtmlFactory.$template.find("." + type);
				var commentList = $(".commentTableContainer ." + type);
				/*
				var method = value ? "show" : "hide";
				header[method]();
				template[method]();
				*/
				header.css("display", value ? "" : "none");
				template.css("display", value ? "" : "none");
				commentList.css("display", value ? "" : "none");
				_CommentHtmlFactory.template = Jarty.compile($(_CommentHtmlFactory.$template[0]).html());
				setCommentTableWidth();
			}, ".left").css("margin-left", "20px");
		})(addTypeList[i]);
		
		esp.addSettingElementCheckbox("useSearchBox", DEFALUT_VALUE_FALSE, "コメントの検索ボックスを表示", function(value){
			useSearchBox = value;
			var method = value ? "show" : "hide";
			header_setting.find(".extendCommentLog_commentSearchBox")[method]();
		}, ".left")
		
		esp.addSettingElementRadioButton("userIdSecondClick", userIdSecondClick_ShowAll, "・ユーザーコメント抽出中にID部分クリック", [userIdSecondClick_ShowAll, userIdSecondClick_NG, userIdSecondClick_DoNothing], ["コメント一覧に戻る（全コメントを表示）", "そのユーザーをNG", "なにもしない"], function(value){
			userIdSecondClick = value;
		}, ".right");
		
		esp.addSettingElementCheckbox("isDebug", DEFALUT_VALUE_FALSE, "デバッグ", function(value){
			isDebug = value;
		}, ".right").css("position", "absolute").css("bottom", "60px").css("right", "25px");
//		esp.addElement('<div class="left"></div><div class="right"></div>');
//		esp.addSettingElementCheckbox("enable2", false, "2 : 有効 or 無効", function(value, settingName, element, event){console.log(arguments);}, ".right");
	}
		
//	header_setting.append('<button class="extendCommentLog_showSettingPanel" title="extendCommentLog（ユーザーIDを表示する拡張）の設定">設定</button>');
	header_setting.find(".threadSelectPanel").after('<button class="extendCommentLog_showSettingPanel" title="extendCommentLog（ユーザーIDを表示する拡張）の設定">設定</button>');
	header_setting.find(".extendCommentLog_showSettingPanel").click(function(){
		esp.show();
//		WatchApp.ns.view.player.setting.PlayerSettingViewController.getInstance().show("extendCommentLog");
//		$("#playerSettingPanelTab .extendCommentLog a").click();
	}).css("margin-bottom", "4px");
	
//	if (isDebug) esp.addSettingElementTextbox("text1", "123", "説明", 5, function(){}, ".left")
	// 保存データのリセット
	// SettingUtil_pr_nl.getInstance("extendCommentLog").resetData()
})
